// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from cascade_lifecycle_msgs:msg/State.idl
// generated code does not contain a copyright notice

#ifndef CASCADE_LIFECYCLE_MSGS__MSG__DETAIL__STATE__TRAITS_HPP_
#define CASCADE_LIFECYCLE_MSGS__MSG__DETAIL__STATE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "cascade_lifecycle_msgs/msg/detail/state__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace cascade_lifecycle_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const State & msg,
  std::ostream & out)
{
  out << "{";
  // member: state
  {
    out << "state: ";
    rosidl_generator_traits::value_to_yaml(msg.state, out);
    out << ", ";
  }

  // member: node_name
  {
    out << "node_name: ";
    rosidl_generator_traits::value_to_yaml(msg.node_name, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const State & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "state: ";
    rosidl_generator_traits::value_to_yaml(msg.state, out);
    out << "\n";
  }

  // member: node_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "node_name: ";
    rosidl_generator_traits::value_to_yaml(msg.node_name, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const State & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace cascade_lifecycle_msgs

namespace rosidl_generator_traits
{

[[deprecated("use cascade_lifecycle_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const cascade_lifecycle_msgs::msg::State & msg,
  std::ostream & out, size_t indentation = 0)
{
  cascade_lifecycle_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use cascade_lifecycle_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const cascade_lifecycle_msgs::msg::State & msg)
{
  return cascade_lifecycle_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<cascade_lifecycle_msgs::msg::State>()
{
  return "cascade_lifecycle_msgs::msg::State";
}

template<>
inline const char * name<cascade_lifecycle_msgs::msg::State>()
{
  return "cascade_lifecycle_msgs/msg/State";
}

template<>
struct has_fixed_size<cascade_lifecycle_msgs::msg::State>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<cascade_lifecycle_msgs::msg::State>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<cascade_lifecycle_msgs::msg::State>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // CASCADE_LIFECYCLE_MSGS__MSG__DETAIL__STATE__TRAITS_HPP_
